#! /usr/bin/env python

import cgi, sys, string, time, os, copy

sys.stderr = sys.stdout        # errors to browser

start_time = 0
end_time = 24
tz = 0
nmonths = 1

def quit() :
    print """
    </body>
    </html>
    """
    sys.exit(0)

# You'd think we could use time module functions to convert
# between time zones, but it turns out that there's no way
# to go from the 9-tuple in UT back to seconds; only a localtime tuple.
def UT2local(utTime, tz) :
    hr = utTime[3] + tz
    day = utTime[2]
    while hr < 0 :
        hr = hr + 24
        day = day - 1
    return (utTime[0], utTime[1], day, hr, utTime[4], utTime[5], \
            utTime[6], utTime[7], utTime[8])

def gmtime2local(m, d, y, h, min) :
    hr = y + tz
    day = d
    while hr < 0 :
        hr = hr + 24
        day = day - 1
    return (y, m, day, hr, min, 0, 0, 0, -1)

def Time2StrOld(tm, showYear) :
    retStr = `tm[1]` + "/" + tm[2]
    if showYear :
        retStr = retStr + "/" + tm[0]
    retStr = retStr + " " + string.zfill(`tm[3]`) + ":" + string.zfill(`tm[4]`)
    return retStr

def Time2Str(tm, showYear) :
    if showYear :
        return time.strftime("%b %d %H:%M %Y", tm)
    return time.strftime("%b %d %H:%M", tm)

def GetPrediction(colong, startmon, startday, startyear) :
    retStr = ""
    try :
        proc = os.popen("./colong -b -t " + colong \
                        + " " + `startmon` + " " + `startyear`)
    except :
        return ""
    prediction = string.split(proc.readline())
    proc.close()
    if len(prediction) < 2 :
        return ""

    # Parse the date
    date = string.split(prediction[0], "/")
    if len(date) < 3 :
        return ""

    # Parse the time
    time = string.split(prediction[1], ":")
    hour = int(time[0])
    if (len(time) >= 2) :
        min = int(time[1])
    else :
        min = 0

#    lt = gmtime2local(int(date[0]), int(date[1]), int(date[2]), hour, min)
#    hour = lt[3]
#    min = lt[4]
    hour = hour + tz
    while hour < 0 :
        hour = hour + 24
        date[1] = string.zfill(`int(date[1]) - 1`, 2)

    # Is it within the time boundaries?
    if start_time < end_time :
        if hour < start_time or hour > end_time :
            return ""
            #return `hour` + " not in (" + `start_time` + ", " +`end_time` +")"
    elif start_time > end_time :
        if hour > end_time and hour < start_time :
            return ""
            #return `hour` + " not in (" + `start_time` + ", " +`end_time` +")"

#    return Time2Str(lt, 0)

    retStr = retStr + date[0] + "/" + date[1]
    # retStr = retStr + "/" + date[2]
    retStr = retStr + " " + `hour` + ":" + string.zfill(`min`, 2)
    return retStr


# Get the cgi arguments
form = cgi.FieldStorage()

print """Content-type: text/html

<html>
<head>
<title>Lunar Feature Predictor</title>
</head>
<body>
<h1>Lunar Feature Predictor</h1>

This page uses the algorithm in Rukl's atlas to calculate
lunar colongitude.  The list of features is not complete
yet.  If you have a particular feature you would like to
see listed here, or if you have a correction to one of the
listed features, or a request for features in the search page,
please <a href="../../mailme.html">tell me</a>.

<p>
You can bookmark this page to save the values you specified
for start time, end time, time zone, etc.

<p>
"""

if form.has_key("start_time") :
    start_time = int(form['start_time'].value)
    #print "Start time:", start_time, "<br>"
if form.has_key("end_time") :
    end_time = int(form['end_time'].value)
    #print "End time:", end_time, "<br>"
if form.has_key("tz") :
    tz = int(form['tz'].value)
    #print "Time zone:", tz, "<br>"
if form.has_key("nmonths") :
    nmonths = int(form['nmonths'].value)
    #print "Predicting for next", nmonths, "months.<br>"

ttime = time.time()
gtime = time.gmtime(ttime)

try :
    fp = os.popen("./colong")
    print "<b>Current colongitude:</b>"
    while (1) :
        line = fp.readline()
        if not line: break;
        print line
        lt = UT2TZ(gtime, tz)
        print "(local: " + Time2Str(lt, 0) + ")"
    fp.close()
except :
    print "\n"

print "<p>\nFeatures visible in the next", nmonths,
if nmonths > 1 :
    print "months"
else:
    print "month"
print "of", gtime[0],
print "between", `start_time` + ":00 and", `end_time` + ":00,"
print "TZ", `tz`, ":"

try :
    fp = open("features", "r")
except :
    print "Couldn't open file"
    quit()

print "\n<p>\n<table border=1>"
print "<tr><th align=left>Colong <th align=left>Rukl<br>Page"
print "<th align=left>Feature"
print "<th colspan=", nmonths, ">Occurrences"

while (1) :
    line = fp.readline()
    if not line: break;

    # Skip blank lines and comments
    if (line == "") :
        continue
    if (line[0] == "#") :
        continue

    fields = string.split(line)
    if (len(fields) < 3) :
        continue

    # Now for the prediction:
    willHappen = 0
    pred = [[]] * nmonths
    for i in range(0, nmonths) :
        pred[i] = GetPrediction(fields[0], gtime[1] + i, gtime[2], gtime[0])
        if pred[i] != "" :
            willHappen = 1
    if willHappen :
        # If we got this far, we're ready to print a table row!
        print "<tr>\n  <td>" + fields[0],
        if (len(fields[1]) <= 1) :
            pageno = "0" + fields[1]
        else :
            pageno = fields[1]
        print "\n  <td><a href=\"http://www.shallowsky.com/moon/rukl" \
              + pageno + ".html\">" + pageno + "</a>"

        # Print all the words in the longdesc:
        print "  <td>",
        for i in range(2, len(fields)) :
            if (string.find(fields[i], "http:") >= 0) :
                print "<a href=\"" + fields[i] + "\">" + fields[i] + "</a>",
            else :
                print fields[i],
        print ""

        for i in range(0, nmonths) :
            print "  <td>", pred[i], "<br>"

fp.close()

print """
</table>

<p>
<a href="index.html">Make another prediction</a>

<hr>

<p>
<center>
<a href="../">Hitchhiker's Guide to the Moon</a> | 
<a href="../search.html">Search the Hitchhiker's Guide</a> | 
<a href="../../index.html">Shallow Sky Home</a> | 
<a href="../../mailme.html">comments or contributions</a><br>
</center>
<p>
<div align=right>
<i>The source code</i>:
<a href="colong..tgz">colong.tgz</a>
</div>

</body>
</html>
"""



