/* feature.h: features used in the lunar colongitude program.
 *
 * Copyright 2003 by Akkana Peck, akkana <at> shallowsky.com.
 * You are free to free to use or modify this software under the GPL.
 */

#ifndef FEATURE_H
#define FEATURE_H

struct LunarFeature
{
    double colong;
    int page;
    char* longdesc;
};

/* Read the next feature in from the given line.
 * If we find one, allocate space and return the new feature.
 */
extern struct LunarFeature* ReadFeature(char* line);
extern void FreeFeature(struct LunarFeature* feature);

/* Find the first feature matching the given string.
 * If we find one, allocate memory for it and return it.
 */
extern struct LunarFeature* GetFeatureByKeyword(const char* keyword,
                                                const char* filename);

#endif /* FEATURE_H */

